import PyIPSDK
import PyIPSDK.IPSDKIPLAdvancedMorphology as advmorpho
import PyIPSDK.IPSDKIPLArithmetic as arithm
import PyIPSDK.IPSDKIPLBinarization as bin
import PyIPSDK.IPSDKIPLGlobalMeasure as glbmsr
import PyIPSDK.IPSDKIPLLogical as logic
import PyIPSDK.IPSDKIPLUtility as util
from UsefullWidgets import Measure

def My_function( inImg1, direction, reverse ):

	print(direction, reverse)

	if(direction=="X"):
		if(reverse==False):
			img2 = arithm.formula2dImg("if ((x==0)&&(I1==1), true, false)", InOptImg1=inImg1)
			img4 = arithm.formula2dImg("if ((x==Sx-1)&&(I1==1), true, false)", InOptImg1=inImg1)
		else:
			img2= arithm.formula2dImg("if ((x==Sx-1)&&(I1==1), true, false)", InOptImg1=inImg1)
			img4 = arithm.formula2dImg("if ((x==0)&&(I1==1), true, false)", InOptImg1=inImg1)
		size = inImg1.getSizeX()

	elif(direction=="Y"):
		if(reverse==False):
			img2 = arithm.formula2dImg("if ((y==0)&&(I1==1), true, false)", InOptImg1=inImg1)
			img4 = arithm.formula2dImg("if ((y==Sy-1)&&(I1==1), true, false)", InOptImg1=inImg1)
		else:
			img2 = arithm.formula2dImg("if ((y==Sy-1)&&(I1==1), true, false)", InOptImg1=inImg1)
			img4 = arithm.formula2dImg("if ((y==0)&&(I1==1), true, false)", InOptImg1=inImg1)
		size = inImg1.getSizeY()

	img3 = util.convertImg(inImg1,PyIPSDK.eIBT_Real32)
	_ = advmorpho.seededDistanceMap2dImg(inImg1, img2,1,1,PyIPSDK.eN2T_8Connexity,img3)
	
	maskRef = bin.lightThresholdImg(img3,1)
	maskRef = logic.bitwiseOrImgImg(maskRef,img2)
	img3 = arithm.addScalarImg(img3,1)
	img3 = logic.maskImg(img3,maskRef)
	
	img5 = logic.bitwiseAndImgImg(inImg1,img4)
	
	img6 = bin.lightThresholdImg(img3,(size-1))
	img6 = logic.bitwiseAndImgImg(img5,img6)
	
	if(inImg1.getSizeZ() == 1):
		output = glbmsr.statsMaskMsr2d(img3,img6)
		maskStats = glbmsr.statsMsr2d(img6)
		
		if maskStats.max==0:
			minVal = 0
		else:
			minVal = output.min

		tortuosity = minVal/size
	
		measureTortuosity = Measure()
		measureTortuosity.subType = "Table"
		measureTortuosity.value = [["Length","Tortuosity"],[minVal,tortuosity]]

	else:
		output = glbmsr.multiSlice_statsMaskMsr2d(img3, img6)
		output = PyIPSDK.toPyDict(output)

		maskStats = glbmsr.multiSlice_statsMsr2d(img6)
		maskStats = PyIPSDK.toPyDict(maskStats)

		measureTortuosity = Measure()
		measureTortuosity.subType = "Table"
		measureTortuosity.value = [["Index","Length","Tortuosity"]]

		for z in range(inImg1.getSizeZ()):
			if maskStats[(z,0,0)]["Max"]==0:
				minVal = 0
			else:
				minVal = output[(z,0,0)]["Min"]
			tortuosity = minVal/size
			measureTortuosity.value.append([z, minVal, tortuosity])
	
	img3.lut = "Magma"
	img3.background = False

	return measureTortuosity, img3





























































